#include <stdio.h>
#include <string.h>
#include <argtable2.h>
#include <signal.h>
#include <stdlib.h>
#include <sys/time.h>
#include <linux/tcp.h>        // TCP_MAXSEG etc.
#include <linux/net.h>        // ioctl - socket enums
#include <netinet/in.h>       // IPPROTO def's
#include <sys/ioctl.h>
#include <errno.h>
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>

// netstat -au -pn -6  shows UDP process-numbers and numbers of ports instead of defaults on IP6
void recvit()
{
   int sock = socket(AF_INET6, SOCK_DGRAM, 0);
   if (sock <= 0)
   {
      printf("Opening socket gave error: %d\n",sock);
      exit(sock);
   }

   // The inet address we will listen at
   struct sockaddr_in6 listen_addr;    
   memset(&listen_addr, 0, sizeof(listen_addr)); 
   listen_addr.sin6_family = AF_INET6 ;    
   listen_addr.sin6_port = htons(2000); 
   listen_addr.sin6_addr = in6addr_any;

/*
    struct ipv6_mreq mreq;
    setsockopt(sock, IPPROTO_IPV6, IPV6_JOIN_GROUP, &mreq, sizeof(mreq)) 

*/ 
   int on=1;
   if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR,
                      (char *)&on,sizeof(on)) < 0)
   {
      printf("setsockopt(SO_REUSEADDR) failed");
      exit(0);
   }

   int err;
   err = bind(sock, (struct sockaddr *) &listen_addr, sizeof(struct sockaddr_in6));      
   if (err)
   {
      printf("Binding gone wrong - error %d\n", err);
      exit(err);
   }
      
   char mystring[100];

   // Space for remote socket data
   struct sockaddr_in6 remote_addr;      
   socklen_t addr_len = (socklen_t) sizeof(remote_addr);  
   
   err = recvfrom(sock, mystring, sizeof(mystring),  0, (struct sockaddr *) &remote_addr, &addr_len);
   if (err < 0)
   {
      printf("Could not recv. Error: %d\n", err);
      exit(err);
   }
   else
      printf("Received: %s", mystring);
}

int main()
{ 
   recvit();
   return 0;
}

